/**
 * generated by Xtext 2.27.0
 */
package no.ntnu.idi.tdt4250.sm.xtext.stateMachineDSL;

import org.eclipse.emf.common.util.EList;

import org.eclipse.emf.ecore.EObject;

/**
 * <!-- begin-user-doc -->
 * A representation of the model object '<em><b>State Machine</b></em>'.
 * <!-- end-user-doc -->
 *
 * <p>
 * The following features are supported:
 * </p>
 * <ul>
 *   <li>{@link no.ntnu.idi.tdt4250.sm.xtext.stateMachineDSL.StateMachine#getName <em>Name</em>}</li>
 *   <li>{@link no.ntnu.idi.tdt4250.sm.xtext.stateMachineDSL.StateMachine#getStates <em>States</em>}</li>
 *   <li>{@link no.ntnu.idi.tdt4250.sm.xtext.stateMachineDSL.StateMachine#getTransitions <em>Transitions</em>}</li>
 * </ul>
 *
 * @see no.ntnu.idi.tdt4250.sm.xtext.stateMachineDSL.StateMachineDSLPackage#getStateMachine()
 * @model
 * @generated
 */
public interface StateMachine extends EObject
{
  /**
   * Returns the value of the '<em><b>Name</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the value of the '<em>Name</em>' attribute.
   * @see #setName(String)
   * @see no.ntnu.idi.tdt4250.sm.xtext.stateMachineDSL.StateMachineDSLPackage#getStateMachine_Name()
   * @model
   * @generated
   */
  String getName();

  /**
   * Sets the value of the '{@link no.ntnu.idi.tdt4250.sm.xtext.stateMachineDSL.StateMachine#getName <em>Name</em>}' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @param value the new value of the '<em>Name</em>' attribute.
   * @see #getName()
   * @generated
   */
  void setName(String value);

  /**
   * Returns the value of the '<em><b>States</b></em>' containment reference list.
   * The list contents are of type {@link no.ntnu.idi.tdt4250.sm.xtext.stateMachineDSL.State}.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the value of the '<em>States</em>' containment reference list.
   * @see no.ntnu.idi.tdt4250.sm.xtext.stateMachineDSL.StateMachineDSLPackage#getStateMachine_States()
   * @model containment="true"
   * @generated
   */
  EList<State> getStates();

  /**
   * Returns the value of the '<em><b>Transitions</b></em>' containment reference list.
   * The list contents are of type {@link no.ntnu.idi.tdt4250.sm.xtext.stateMachineDSL.Transition}.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the value of the '<em>Transitions</em>' containment reference list.
   * @see no.ntnu.idi.tdt4250.sm.xtext.stateMachineDSL.StateMachineDSLPackage#getStateMachine_Transitions()
   * @model containment="true"
   * @generated
   */
  EList<Transition> getTransitions();

} // StateMachine
